{% macro header_start() -%}
                                            <th>{{ _('Source') }}</th>
                                            <th>{{ _('First event') }}</th>
                                            <th>{{ _('Last event') }}</th>
                                            <th style="text-align:right">{{ _('Detectors') }}</th>
                                            <th style="text-align:right">{{ _('Messages') }}</th>
{%- endmacro %}

{% macro header(data, dafault_class) %}
                                            {{ header_start() }}
                                            <th>{{ _('Protocol') }}</th>
{% endmacro %}

{% macro protocols(data) -%}
                                                <td>{% if 'source' in data and 'target' in data and (data['source']['proto'] or data['target']['proto']) %}{{ ', '.join((data['source']['proto'] + data['target']['proto']) | unique(case_sensitive=True) | sort) }}{% elif data['ports'] %}{{ ', '.join(data['ports']) }}{% else %}---{% endif %}</td>
{%- endmacro %}

{% macro format_number(number, empty_value='---') -%}
<td style="text-align:right">{% if number %}{{ number }}{% else %}{{ empty_value }}{% endif %}</td>
{%- endmacro %}



{% macro render_different_time_formats(key, time) %}
                                                    {% set k = (key | replace('.', '') | replace(':', '')) ~ '-' ~ (range(1, 1000) | random) %}
                                                    <div class="popover-hover-container">
                                                        <div class="popover-hover" data-popover-content="#popover-{{ k }}">
                                                            <div class="underlined-tooltip">{{ format_datetime_wz(time, None, tz) }}</div>
                                                            <div id="popover-{{ k }}" class="hidden">
                                                                <div class="popover top">
                                                                    <div class="arrow"></div>
                                                                    <div class="popover-content" style="font-size:small">
                                                                        {{ format_datetime(time, tz) }}
                                                                        {% if tz != tz_utc -%}
                                                                        <br/>
                                                                        {{ format_datetime(time, tz_utc) }}
                                                                        {%- endif %} 
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </div>
{%- endmacro %}

{% macro row_start(key, data, is_authenticated) -%}
                                                {% if is_authenticated -%}
                                                <td>{{ macros_site.render_widget_csag_address([key]) }}</td>
                                                {% else -%}
                                                <td>{{ key }}</td>
                                                {% endif -%}
                                                <td>{{ render_different_time_formats(key, data['first_time']) }}</td>
                                                <td>{{ render_different_time_formats(key, data['last_time']) }}</td>
                                                {{ format_number(data['detectors_count']) }}
                                                {{ format_number(data['count']) }}
{%- endmacro %}

{% macro row(key, data, is_authenticated, dafault_class) %}
                                                {{ row_start(key, data) }}
                                                {{ protocols(data) }}
{% endmacro %}
